# Menue&TextCtrl_ENTER.py
# Oeffnen und Speichern realisiert
# Textfenster ist mehrzeilig

import wx
import os # notwendig fuer die Dateizugriffe

import platform
versionsNummer=platform.python_version()[0]
### ---------------------------------------------------
class Gui(wx.Frame):
    def __init__(
            self, parent, ID, title, pos=wx.DefaultPosition,
            size=wx.DefaultSize, style=wx.DEFAULT_FRAME_STYLE
            ):

        wx.Frame.__init__(self, parent, ID, title, pos, size, style)
        panel = wx.Panel(self, -1)

        ### Label und TextCtrl
        self.label1 = wx.StaticText(panel, -1, "Ein/Ausgabe")
        self.label1.SetPosition((155, 15))
        self.textCtrl1 = wx.TextCtrl(panel, -1,
                                     "noch ohne Inhalt",
                                     size=(200, 150),
                                     style=wx.TE_MULTILINE)
        self.textCtrl1.SetPosition((155, 15))

        ### Menu-Abschnitt
        # Prepare the menu bar
        menuBar = wx.MenuBar()

        # einziges Menue
        dateiMenu = wx.Menu()
        dateiMenu.Append(101, "Oeffnen")
        dateiMenu.Append(102, "Speichern")
        dateiMenu.AppendSeparator()
        dateiMenu.Append(103, "Beenden")
        # Add menu to the menu bar
        menuBar.Append(dateiMenu, "Datei")
        
        self.SetMenuBar(menuBar)

        ### Menu events
        self.Bind(wx.EVT_MENU, self.OnOeffnen, id=101)
        self.Bind(wx.EVT_MENU, self.OnSpeichern, id=102)
        self.Bind(wx.EVT_MENU, self.OnBeenden, id=103)

        ### Fensterereignis
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)

    ### Ereignisbehandlung ###
        
    ### Menu-Abschnitt
    def OnOeffnen(self, event):
        if wx.PlatformInfo[1]=='wxMSW':
            standardVerzeichnis=os.getcwd()+"\\Daten"
        else:
            standardVerzeichnis="Daten"
        if versionsNummer=='2': 
            dlg = wx.FileDialog(
                self, message=u"Datei wählen",
                defaultDir=standardVerzeichnis, 
                defaultFile="daten.dat",
                style=wx.OPEN
                )
        else:
            dlg = wx.FileDialog(
                self, message=u"Datei wählen",
                defaultDir=standardVerzeichnis,
                defaultFile="daten.dat",
                style=wx.FD_OPEN
                )
        if dlg.ShowModal() == wx.ID_OK:
            dateiname = dlg.GetPath()
            antwort=self._Lesen(dateiname)
            if antwort!='OK':
                message = wx.MessageDialog(self, antwort,
                                           'Achtung',
                                           wx.OK | wx.ICON_WARNING)
                message.ShowModal()
                message.Destroy()
        dlg.Destroy()

    def _Lesen(self, dateiname):
        '''laedt die Daten aus der Datei'''
        try:
            f=open(dateiname,'r')
        except IOError as e:
            self.textCtrl1.SetValue('Datei existiert nicht, keine Daten gelesen')
            return None
        text=f.read()
        self.textCtrl1.SetValue(text)
        f.close()
        return 'OK'


    def OnSpeichern(self, event):
        if wx.PlatformInfo[1]=='wxMSW':
            standardVerzeichnis=os.getcwd()+"\\Daten"
        else:
            standardVerzeichnis="Daten"
        if versionsNummer=='2': 
            dlg = wx.FileDialog(
                self, message="Datei speichern",
                defaultDir=standardVerzeichnis, 
                defaultFile="daten.dat", style=wx.SAVE
                )
        else:
            dlg = wx.FileDialog(
                self, message="Datei speichern",
                defaultDir=standardVerzeichnis, 
                defaultFile="daten.dat", style=wx.FD_SAVE
                )
        if dlg.ShowModal() == wx.ID_OK:
            dateiname = dlg.GetPath()
            antwort=self._schreiben(dateiname)
            if antwort!='OK':
                message = wx.MessageDialog(self, antwort,
                                           'Achtung',
                                           wx.OK | wx.ICON_WARNING)
                message.ShowModal()
                message.Destroy()
        dlg.Destroy()

    def _schreiben(self, dateiname):
        try:
            f=open(dateiname,'w')
        except IOError as e:
            self.textCtrl1.SetValue('Datei existiert nicht, keine Daten geschrieben')
            return None
        f.write( self.textCtrl1.GetValue() )
        f.close()
        return 'OK'        

    ### Button-Abschnitt
    def OnBeenden(self, event):
        self.Close(True)

    def OnCloseWindow(self, event):
        self.Destroy()

### ---------------------------------------------------
class RaumplanerApp(wx.App):
    """Anwendung fuer Raumplaner"""
    def OnInit(self):
        self.fenster = Gui(None, 1000, "Raumplaner")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        return True

### ---------------------------------------------------
if __name__ == '__main__':
    app = RaumplanerApp(redirect=False)
    app.MainLoop()
